/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.69
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.48 2011/01/12 21:24:58 dilfridge Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.69 2013/02/07 03:38:33 alexxy Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
15inherit kde4-base versionator 17inherit kde4-base versionator
16 18
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 19KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
18 20EXPORT_FUNCTIONS ${KDEMETA_EXPF}
19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
20 21
21# Add dependencies that all packages in a certain module share. 22# Add dependencies that all packages in a certain module share.
22case ${KMNAME} in 23case ${KMNAME} in
23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics) 24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4" 25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
25 ;; 26 ;;
26 kdepim|kdepim-runtime) 27 kdepim|kdepim-runtime)
27 case ${PN} in 28 case ${PN} in
28 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
34 kdegames) 35 kdegames)
35 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
36 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)" 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
37 fi 38 fi
38 ;; 39 ;;
39 koffice)
40 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
41 RDEPEND+="
42 !app-office/${PN}:0
43 !app-office/koffice:0
44 !app-office/koffice-meta:0
45 "
46 if has openexr ${IUSE//+}; then
47 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
48 else
49 COMMONDEPEND+=" media-gfx/imagemagick"
50 fi
51
52 COMMONDEPEND+="
53 dev-cpp/eigen:2
54 media-libs/fontconfig
55 media-libs/freetype:2
56 "
57 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
58 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
59 fi
60 ;;
61esac 40esac
62 41
63DEPEND+=" ${COMMONDEPEND}" 42DEPEND+=" ${COMMONDEPEND}"
64RDEPEND+=" ${COMMONDEPEND}" 43RDEPEND+=" ${COMMONDEPEND}"
65unset COMMONDEPEND 44unset COMMONDEPEND
66 45
67debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 46debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
68debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 47debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
69 48
70# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 49# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
71case ${BUILD_TYPE} in 50case ${KDE_BUILD_TYPE} in
72 live) 51 live)
52 if [[ ${KDE_SCM} == svn ]]; then
73 case ${KMNAME} in 53 case ${KMNAME} in
74 extragear*|playground*) 54 extragear*|playground*)
75 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 55 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
76 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}" 56 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
77 ;; 57 ;;
78 esac 58 esac
59 fi
79 ;; 60 ;;
80esac 61esac
81 62
82# @ECLASS-VARIABLE: KMNAME 63# @ECLASS-VARIABLE: KMNAME
83# @DESCRIPTION: 64# @DESCRIPTION:
127# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 108# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
128# '-xpf -j' are passed to tar by default. 109# '-xpf -j' are passed to tar by default.
129 110
130# @FUNCTION: kde4-meta_pkg_setup 111# @FUNCTION: kde4-meta_pkg_setup
131# @DESCRIPTION: 112# @DESCRIPTION:
132# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 113# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
133# split ebuilds. 114# Use this one in split ebuilds.
134kde4-meta_pkg_setup() { 115kde4-meta_pkg_setup() {
135 debug-print-function ${FUNCNAME} "$@" 116 debug-print-function ${FUNCNAME} "$@"
136 117
137 kde4-base_pkg_setup 118 kde4-base_pkg_setup
138} 119}
139 120
140# @FUNCTION: kde4-meta_src_unpack 121# @FUNCTION: kde4-meta_src_unpack
141# @DESCRIPTION: 122# @DESCRIPTION:
142# This function unpacks the source for split ebuilds. See also 123# This function unpacks the source for split ebuilds.
143# kde4-meta-src_extract. 124# Further more is processed in kde4-meta_src_extract
144kde4-meta_src_unpack() { 125kde4-meta_src_unpack() {
145 debug-print-function ${FUNCNAME} "$@" 126 debug-print-function ${FUNCNAME} "$@"
146 127
147 if [[ ${BUILD_TYPE} = live ]]; then 128 if [[ ${KDE_BUILD_TYPE} = live ]]; then
129 case "${KDE_SCM}" in
130 svn)
148 migrate_store_dir 131 migrate_store_dir
149 S="${WORKDIR}/${P}" 132 S="${WORKDIR}/${P}"
150 mkdir -p "${S}" 133 mkdir -p "${S}"
151 ESVN_RESTRICT="export" subversion_src_unpack 134 ESVN_RESTRICT="export" subversion_src_unpack
152 subversion_wc_info 135 subversion_wc_info
153 subversion_bootstrap 136 subversion_bootstrap
137 ;;
138 git)
139 git-2_src_unpack
140 ;;
141 esac
142 fi
154 kde4-meta_src_extract 143 kde4-meta_src_extract
155 else
156 kde4-meta_src_extract
157 fi
158} 144}
159
160# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
161 145
162# @FUNCTION: kde4-meta_src_extract 146# @FUNCTION: kde4-meta_src_extract
163# @DESCRIPTION: 147# @DESCRIPTION:
164# A function to unpack the source for a split KDE ebuild. 148# A function to extract the source for a split KDE ebuild.
165# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 149# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
166# KMTARPARAMS. 150# KMTARPARAMS.
167kde4-meta_src_extract() { 151kde4-meta_src_extract() {
168 debug-print-function ${FUNCNAME} "$@" 152 debug-print-function ${FUNCNAME} "$@"
169 153
170 if [[ ${BUILD_TYPE} = live ]]; then 154 if [[ ${KDE_BUILD_TYPE} = live ]]; then
171 local rsync_options subdir kmnamedir targetdir
172 # Export working copy to ${S} 155 # Export working copy to ${S}
173 einfo "Exporting parts of working copy to ${S}" 156 einfo "Exporting parts of working copy to ${S}"
174 kde4-meta_create_extractlists 157 kde4-meta_create_extractlists
175 158
159 case ${KDE_SCM} in
160 svn)
161 local rsync_options subdir targetdir wc_path escm
162
176 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 163 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
164 wc_path="${ESVN_WC_PATH}"
165 escm="{ESVN}"
177 166
178 # Copy ${KMNAME} non-recursively (toplevel files) 167 # Copy ${KMNAME} non-recursively (toplevel files)
179 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 168 rsync ${rsync_options} "${wc_path}"/* "${S}" \
180 || die "${ESVN}: can't export toplevel files to '${S}'." 169 || die "${escm}: can't export toplevel files to '${S}'."
181 # Copy cmake directory 170 # Copy cmake directory
182 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 171 if [[ -d "${wc_path}/cmake" ]]; then
183 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 172 rsync --recursive ${rsync_options} "${wc_path}/cmake" "${S}" \
184 || die "${ESVN}: can't export cmake files to '${S}'." 173 || die "${escm}: can't export cmake files to '${S}'."
185 fi 174 fi
186 # Copy all subdirectories 175 # Copy all subdirectories
187 for subdir in $(__list_needed_subdirectories); do 176 for subdir in $(__list_needed_subdirectories); do
188 targetdir="" 177 targetdir=""
189 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 178 if [[ $subdir = doc/* && ! -e "$wc_path/$subdir" ]]; then
190 continue 179 continue
191 fi 180 fi
192 181
193 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 182 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
194 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 183 rsync --recursive ${rsync_options} "${wc_path}/${subdir%/}" "${S}/${targetdir}" \
195 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 184 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
196 done 185 done
197
198 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
199 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
200 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
201 fi
202 else
203 local abort tarball tarfile f extractlist moduleprefix postfix
204 case ${PV} in
205 4.[45].8[05] | 4.[45].9[023568])
206 # Block for normally packed upstream unstable snapshots
207 KMTARPARAMS+=" --bzip2" # bz2
208 postfix="bz2"
209 ;;
210 *)
211 KMTARPARAMS+=" --bzip2" # bz2
212 postfix="bz2"
213 ;; 186 ;;
214 esac 187 esac
188 else
189 local abort tarball tarfile f extractlist postfix
190
191 if [[ ${PV} =~ 4.[47].[12345] ]]; then
192 postfix="bz2"
193 KMTARPARAMS+=" --bzip2"
194 else
195 postfix="xz"
196 KMTARPARAMS+=" --xz"
197 fi
198
215 case ${KMNAME} in 199 case ${KMNAME} in
216 kdebase-apps) 200 kdebase-apps)
217 # kdebase/apps -> kdebase-apps 201 # kdebase/apps -> kdebase-apps
218 tarball="kdebase-${PV}.tar.${postfix}" 202 tarball="kdebase-${PV}.tar.${postfix}"
219 # Go one level deeper for kdebase-apps in tarballs
220 moduleprefix=apps/
221 KMTARPARAMS+=" --transform=s|apps/||"
222 ;;
223 kdepim)
224 if [[ ${PV} == 4.5.93 ]] ; then
225 tarball="kdepim-4.6beta3.tar.${postfix}"
226 else
227 tarball="${KMNAME}-${PV}.tar.${postfix}"
228 fi
229 ;; 203 ;;
230 *) 204 *)
231 # Create tarball name from module name (this is the default) 205 # Create tarball name from module name (this is the default)
232 tarball="${KMNAME}-${PV}.tar.${postfix}" 206 tarball="${KMNAME}-${PV}.tar.${postfix}"
233 ;; 207 ;;
242 216
243 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 217 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
244 218
245 kde4-meta_create_extractlists 219 kde4-meta_create_extractlists
246 220
247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 221 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
248 AUTHORS COPYING INSTALL README NEWS ChangeLog
249 do 222 do
250 extractlist+=" ${topdir}${moduleprefix}${f}" 223 extractlist+=" ${topdir}${f}"
251 done 224 done
252 extractlist+=" $(__list_needed_subdirectories)" 225 extractlist+=" $(__list_needed_subdirectories)"
253 226
254 pushd "${WORKDIR}" > /dev/null 227 pushd "${WORKDIR}" > /dev/null
228
229 # @ECLASS-VARIABLE: KDE4_STRICTER
230 # @DESCRIPTION:
231 # Print out all issues found executing tar / kmextract files
232 # Set on if you want to find issues in kde-base ebuild unpack sequences
255 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 233 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
256 if [[ ${I_KNOW_WHAT_I_AM_DOING} ]]; then
257 # to make the devs happy - bug 338397
258 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
259 else
260 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway" 234 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
261 fi
262 235
263 # Default $S is based on $P; rename the extracted directory to match $S if necessary 236 # Default $S is based on $P; rename the extracted directory to match $S if necessary
237 if [[ ${KMNAME} != ${PN} ]]; then
264 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\"" 238 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
239 fi
265 240
266 popd > /dev/null 241 popd > /dev/null
267 242
268 eend $? 243 eend $?
269
270 # We need to clear it here to make verification below work
271 unset moduleprefix
272 244
273 if [[ -n ${KDE4_STRICTER} ]]; then 245 if [[ -n ${KDE4_STRICTER} ]]; then
274 for f in $(__list_needed_subdirectories fatal); do 246 for f in $(__list_needed_subdirectories fatal); do
275 if [[ ! -e "${S}/${f#*/}" ]]; then 247 if [[ ! -e ${S}/${f#*/} ]]; then
276 eerror "'${f#*/}' is missing" 248 eerror "'${f#*/}' is missing"
277 abort=true 249 abort=true
278 fi 250 fi
279 done 251 done
280 [[ -n ${abort} ]] && die "There were missing files." 252 [[ -n ${abort} ]] && die "There were missing files."
293kde4-meta_create_extractlists() { 265kde4-meta_create_extractlists() {
294 debug-print-function ${FUNCNAME} "$@" 266 debug-print-function ${FUNCNAME} "$@"
295 267
296 # Add default handbook locations 268 # Add default handbook locations
297 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5. 269 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
298 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then 270 if [[ $(get_kde_version) < 4.5 ]] && use_if_iuse handbook && [[ -z ${KMNOMODULE} ]]; then
299 # We use the basename of $KMMODULE because $KMMODULE can contain 271 # We use the basename of $KMMODULE because $KMMODULE can contain
300 # the path to the module subdirectory. 272 # the path to the module subdirectory.
301 KMEXTRA_NONFATAL+=" 273 KMEXTRA_NONFATAL+="
302 doc/${KMMODULE##*/}" 274 doc/${KMMODULE##*/}"
303 fi 275 fi
304 276
305 # Add default handbook locations 277 # Add default handbook locations
306 if [[ -z ${KMNOMODULE} ]] && { [[ ${KDE_HANDBOOK} = always ]] || { [[ ${KDE_HANDBOOK} = optional ]] && use handbook; }; }; then 278 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
307 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}" 279 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
308 fi 280 fi
309 281
310 # Add some CMake-files to KMEXTRACTONLY. 282 # Add some CMake-files to KMEXTRACTONLY.
311 # Note that this actually doesn't include KMEXTRA handling. 283 # Note that this actually doesn't include KMEXTRA handling.
312 # In those cases you should care to add the relevant files to KMEXTRACTONLY 284 # In those cases you should care to add the relevant files to KMEXTRACTONLY
313 case ${KMNAME} in 285 case ${KMNAME} in
314 kdebase) 286 kdebase | kdebase-apps | kde-baseapps)
315 KMEXTRACTONLY+=" 287 KMEXTRACTONLY+="
316 apps/config-apps.h.cmake 288 CTestConfig.cmake
317 apps/ConfigureChecks.cmake"
318 ;;
319 kdebase-apps)
320 KMEXTRACTONLY+="
321 config-apps.h.cmake 289 config-apps.h.cmake
322 ConfigureChecks.cmake" 290 ConfigureChecks.cmake"
323 ;; 291 ;;
324 kdebase-runtime) 292 kdebase-runtime | kde-runtime)
325 KMEXTRACTONLY+=" 293 KMEXTRACTONLY+="
294 CTestConfig.cmake
326 config-runtime.h.cmake" 295 config-runtime.h.cmake"
327 ;; 296 ;;
328 kdebase-workspace) 297 kdebase-workspace | kde-workspace)
329 KMEXTRACTONLY+=" 298 KMEXTRACTONLY+="
330 config-unix.h.cmake 299 config-unix.h.cmake
331 ConfigureChecks.cmake 300 ConfigureChecks.cmake
332 config-workspace.h.cmake 301 config-workspace.h.cmake
333 config-X11.h.cmake 302 config-X11.h.cmake
346 KMEXTRACTONLY+=" 315 KMEXTRACTONLY+="
347 libkdepim/" 316 libkdepim/"
348 fi 317 fi
349 KMEXTRACTONLY+=" 318 KMEXTRACTONLY+="
350 config-enterprise.h.cmake 319 config-enterprise.h.cmake
351 kleopatra/ConfigureChecks.cmake" 320 kleopatra/ConfigureChecks.cmake
352 if slot_is_at_least 4.5 ${SLOT}; then
353 KMEXTRACTONLY+="
354 CTestCustom.cmake 321 CTestCustom.cmake
355 kdepim-version.h.cmake" 322 kdepim-version.h.cmake
356 else
357 KMEXTRACTONLY+="
358 kdepim-version.h" 323 kdepim-version.h"
359 fi 324 if use_if_iuse kontact; then
360 if has kontact ${IUSE//+} && use kontact; then
361 KMEXTRA+=" 325 KMEXTRA+="
362 kontact/plugins/${PLUGINNAME:-${PN}}/" 326 kontact/plugins/${PLUGINNAME:-${PN}}/"
363 fi 327 fi
364 ;; 328 ;;
365 kdeutils) 329 kdeutils)
366 KMEXTRACTONLY+=" 330 KMEXTRACTONLY+="
367 kdeutils-version.h" 331 kdeutils-version.h"
368 ;; 332 ;;
369 koffice)
370 KMEXTRACTONLY+="
371 filters/config-filters.h.cmake
372 "
373 case ${PV} in
374 2.0.*)
375 KMEXTRACTONLY+="
376 config-openctl.h.cmake
377 config-endian.h.cmake
378 config-openexr.h.cmake
379 config-opengl.h.cmake
380 config-prefix.h.cmake"
381 ;;
382 2.[12].*)
383 KMEXTRACTONLY+="
384 config-endian.h.cmake
385 config-openexr.h.cmake
386 config-opengl.h.cmake
387 config-prefix.h.cmake"
388 ;;
389 esac
390 ;;
391 esac 333 esac
392 # Don't install cmake modules for split ebuilds, to avoid collisions. 334 # Don't install cmake modules for split ebuilds, to avoid collisions.
335 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
336 # should not try in that case
337 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
338 # it may be possible to formulate this shorter, but it should also
339 # still be understandable...
340 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
341 && ! [[ ${KMNAME} == kdeedu && ( ${PV} == 4.6.4 || ${PV} == 4.6.5 ) ]] \
342 && ! [[ ${KMNAME} == kdegames && ${PV} > 4.9.0 ]]; then
393 case ${KMNAME} in 343 case ${KMNAME} in
394 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics) 344 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
395 case ${PN} in
396 libkdegames|libkdeedu|libkworkspace)
397 KMEXTRA+=" 345 KMEXTRACTONLY+="
398 cmake/modules/" 346 cmake/modules/"
399 ;; 347 ;;
400 *)
401 KMCOMPILEONLY+="
402 cmake/modules/"
403 ;;
404 esac 348 esac
405 ;; 349 fi
406 esac
407 350
408 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 351 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
409} 352}
410 353
411__list_needed_subdirectories() { 354__list_needed_subdirectories() {
450 # Create final list of stuff to extract 393 # Create final list of stuff to extract
451 # We append topdir only when specified (usually for tarballs) 394 # We append topdir only when specified (usually for tarballs)
452 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 395 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
453 ${KMEXTRACTONLY} 396 ${KMEXTRACTONLY}
454 do 397 do
455 extractlist+=" ${topdir}${moduleprefix}${i}" 398 extractlist+=" ${topdir}${i}"
456 done 399 done
457 400
458 echo ${extractlist} 401 echo ${extractlist}
459} 402}
460 403
466 409
467 kde4-meta_change_cmakelists 410 kde4-meta_change_cmakelists
468 kde4-base_src_prepare 411 kde4-base_src_prepare
469} 412}
470 413
471# FIXME: no comment here? 414# @FUNCTION: _change_cmakelists_parent_dirs
415# @DESCRIPTION:
416# Adjust CMakeLists.txt to shadow subdirectories
417# that are not required for the build.
472_change_cmakelists_parent_dirs() { 418_change_cmakelists_parent_dirs() {
473 debug-print-function ${FUNCNAME} "$@" 419 debug-print-function ${FUNCNAME} "$@"
474 420
475 local _olddir _dir 421 local _olddir _dir
476 _dir="${S}"/${1} 422 _dir="${S}"/${1}
477 until [[ ${_dir} == "${S}" ]]; do 423 until [[ ${_dir} == ${S} ]]; do
478 _olddir=$(basename "${_dir}") 424 _olddir=$(basename "${_dir}")
479 _dir=$(dirname "${_dir}") 425 _dir=$(dirname "${_dir}")
480 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 426 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
481 if [[ -f ${_dir}/CMakeLists.txt ]]; then 427 if [[ -f ${_dir}/CMakeLists.txt ]]; then
482 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 428 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
498 444
499 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 445 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
500 if [[ -f CMakeLists.txt ]]; then 446 if [[ -f CMakeLists.txt ]]; then
501 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 447 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
502 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 448 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
449 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
450 fi
451
452 # Restore "add_subdirectory( ${ ..." (this is done in kdesdk)
453 if [[ -f CMakeLists.txt ]]; then
454 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
455 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
503 -i CMakeLists.txt || die "${LINENO}: cmake sed died" 456 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
504 fi 457 fi
505 458
506 if [[ -z ${KMNOMODULE} ]]; then 459 if [[ -z ${KMNOMODULE} ]]; then
507 # Restore "add_subdirectory" in $KMMODULE subdirectories 460 # Restore "add_subdirectory" in $KMMODULE subdirectories
553 _change_cmakelists_parent_dirs ${i} 506 _change_cmakelists_parent_dirs ${i}
554 fi 507 fi
555 done 508 done
556 509
557 case ${KMNAME} in 510 case ${KMNAME} in
558 kdebase-workspace) 511 kdebase-workspace | kde-workspace)
559 # COLLISION PROTECT section 512 # COLLISION PROTECT section
560 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 513 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
561 # not as a part of every package. 514 # not as a part of every package.
562 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then 515 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
563 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 516 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
564 sed -e '/startkde/s/^/#DONOTINSTALL /' \ 517 sed -e '/startkde/s/^/#DONOTINSTALL /' \
565 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 518 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
566 fi 519 fi
520 # Remove workspace target prefix in order to get direct linking to workspace libs
521 sed -e '/set(KDE4WORKSPACE_TARGET_PREFIX/s/^/#OVERRIDE /' \
522 -i CMakeLists.txt || die "${LINENO}: sed died in KDE4WORKSPACE_TARGET_PREFIX removal section"
567 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 523 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
568 if [[ ${PN} != libkworkspace ]]; then 524 if [[ ${PN} != libkworkspace ]]; then
569 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 525 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
570 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section" 526 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace strip config install and fix EXPORT section"
571 fi 527 fi
528 if [[ ${PN} != plasma-workspace ]]; then
529 sed -e '/KActivities/s/REQUIRED//' \
530 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace dep reduction section"
531 fi
532 if [[ "${PN}" != "kwin" ]]; then
533 sed -i -e "/^ macro_log_feature(OPENGL_OR_ES_FOUND/s/TRUE/FALSE/" \
534 "${S}"/CMakeLists.txt || die "${LINENO}: sed died removing kde-workspace opengl dependency"
535 fi
572 ;; 536 ;;
573 kdebase-runtime) 537 kdebase-runtime | kde-runtime)
574 # COLLISION PROTECT section 538 # COLLISION PROTECT section
575 # Only install the kde4 script as part of kde-base/kdebase-data 539 # Only install the kde4 script as part of kde-base/kdebase-data
576 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then 540 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
577 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 541 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
578 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 542 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
586 kdepim) 550 kdepim)
587 # Disable hardcoded checks 551 # Disable hardcoded checks
588 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \ 552 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
589 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \ 553 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
590 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \ 554 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
591 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \ 555 -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*/if(1) # &/' \
592 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \ 556 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
593 -i CMakeLists.txt || die "failed to disable hardcoded checks" 557 -i CMakeLists.txt || die "failed to disable hardcoded checks"
594 # Disable broken or redundant build logic 558 # Disable broken or redundant build logic
595 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then 559 if use_if_iuse kontact || [[ ${PN} = kontact ]]; then
596 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \ 560 sed -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*$/if(1) # &/' \
597 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \ 561 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
598 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic' 562 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
599 fi 563 fi
600 if ! slot_is_at_least 4.5 ${SLOT}; then 564 case ${PV} in
565 4.4*)
601 case ${PN} in 566 case ${PN} in
602 kalarm|kmailcvt|kontact|korganizer|korn) 567 kalarm|kmailcvt|kontact|korganizer|korn)
603 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 568 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
604 -e '/add_custom_target(kmail_xml /,/)/p' \ 569 -e '/add_custom_target(kmail_xml /,/)/p' \
605 -i kmail/CMakeLists.txt || die "uncommenting xml failed" 570 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
606 _change_cmakelists_parent_dirs kmail 571 _change_cmakelists_parent_dirs kmail
572 ;;
573 esac
607 ;; 574 ;;
608 esac 575 esac
609 fi
610 ;; 576 ;;
611 kdewebdev) 577 kdewebdev)
612 # Disable hardcoded checks 578 # Disable hardcoded checks
613 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 579 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
614 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \ 580 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
615 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \ 581 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
616 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \ 582 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
617 -i CMakeLists.txt || die "failed to disable hardcoded checks" 583 -i CMakeLists.txt || die "failed to disable hardcoded checks"
618 ;; 584 ;;
619 koffice)
620 # Prevent collisions
621 if [[ ${PN} != koffice-data ]]; then
622 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
623 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
624 sed -e '/install(.\+config-openexr\.h.\+)/d' \
625 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
626 fi
627 # koffice 2.0
628 case ${PV} in
629 2.0.[1-9])
630 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
631 "${S}"/CMakeLists.txt || \
632 die "${LINENO}: sed died in collision prevention section"
633 ;;
634 *) ;;
635 esac
636 # koffice 2.1.[8-9][0-9] and 9999
637 case ${PV} in
638 2.1.8[0-9]|2.1.9[0-9]|9999)
639 sed -e '/^option(BUILD/s/ON/OFF/' \
640 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
641 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
642 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
643 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
644 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
645 sed -e '/config-opengl.h/d' \
646 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
647
648 fi
649 ;;
650 *) ;;
651 esac
652 esac 585 esac
653 586
654 popd > /dev/null 587 popd > /dev/null
655} 588}
656 589
676 -DWITH_Boost=OFF 609 -DWITH_Boost=OFF
677 -DWITH_LibTidy=OFF 610 -DWITH_LibTidy=OFF
678 "${mycmakeargs[@]}" 611 "${mycmakeargs[@]}"
679 ) 612 )
680 ;; 613 ;;
681 koffice)
682 case ${PV} in
683 2.1.8[0-9]|2.1.9[0-9]|9999)
684 if [[ ${PN} != "kchart" ]]; then
685 mycmakeargs=(
686 -DBUILD_koreport=OFF
687 "${mycmakeargs[@]}"
688 )
689 fi
690 ;;
691 esac
692 ;;
693 esac 614 esac
694 615
695 kde4-base_src_configure 616 kde4-base_src_configure
696} 617}
697 618
732 done 653 done
733 654
734 kde4-base_src_install 655 kde4-base_src_install
735} 656}
736 657
658# @FUNCTION: kde4-meta_pkg_preinst
659# @DESCRIPTION:
660# Invoke its equivalent in kde4-base.eclass.
661kde4-meta_pkg_preinst() {
662 debug-print-function ${FUNCNAME} "$@"
663
664 kde4-base_pkg_preinst
665}
666
737# @FUNCTION: kde4-meta_pkg_postinst 667# @FUNCTION: kde4-meta_pkg_postinst
738# @DESCRIPTION: 668# @DESCRIPTION:
739# Invoke kbuildsycoca4. 669# Invoke kbuildsycoca4.
740kde4-meta_pkg_postinst() { 670kde4-meta_pkg_postinst() {
741 debug-print-function ${FUNCNAME} "$@" 671 debug-print-function ${FUNCNAME} "$@"

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.69

  ViewVC Help
Powered by ViewVC 1.1.20